
#include "Arduino.h"

char pwmPin = 5; // OC3A (timer 3, Output compare A), PE3 (port E sortie 3)
char clockBits;
volatile uint32_t count;
int32_t max_count;
uint16_t diviseur[6] = {0,1,8,64,256,1024};
              
void pulse_train(uint32_t period, int32_t nombre, float rapport) { 
  TCCR3A = 0;
  TCCR3A |= (1 << COM3A1) | (1 << COM3A0);
  TCCR3B = 1 << WGM13; // phase and frequency correct pwm mode, top = ICR3
  uint32_t icr = (F_CPU/1000000*period/2);
  int d = 1;
  while ((icr>0xFFFF)&&(d<5)) {
     d++;
     icr = (F_CPU/1000000*period/2/diviseur[d]);
   } 
  clockBits = d;
  uint16_t ocra = icr * (1.0-rapport);
  ICR3 = icr;
  OCR3A = ocra;
  TIMSK3 = 1 << TOIE3; // overflow interrupt enable
  sei();
  count = 0;
  max_count = nombre+1;
  TCNT3 = 0; // mise à zéro du compteur
  TCCR3B |= clockBits;
}
                
ISR(TIMER3_OVF_vect) { // Overflow interrupt
   count++;
    if (count==max_count) {
      TCCR3B &= ~0x7;
      TCCR3A = 0;
      PORTE &= ~(1 << PORTE3);
      TCNT3 = 0;
   } 
}
                
void setup() {
  DDRE |= 1 << PORTE3; // data direction register
  PORTE &= ~(1 << PORTE3);
}
                
void loop() {
    delay(1000);
    pulse_train(100,10,0.2);

}
                